package com.shadeslider.project.views 
{
    import com.shadeslider.base.*;
    import com.shadeslider.project.events.*;
    import com.shadeslider.project.models.*;
    import com.shadeslider.utils.*;
    import flash.display.*;
    import flash.events.*;
    import flash.text.*;
    import flash.utils.*;
    
    public class ToolbarView extends com.shadeslider.base.CompositeView
    {
        public function ToolbarView(arg1:flash.display.MovieClip, arg2:com.shadeslider.project.models.MainModel, arg3:Object)
        {
            super(arg1, arg2, arg3);
            this.cityList = config.cityList;
            this.cityItemsClip = stageClip.cityDD.items;
            this.cityItemsScrollingTimer = new flash.utils.Timer(1000 / 60);
            this.addStageListeners();
            this.update();
            return;
        }

        private function cityDDArrowUpRollOverHandler(arg1:flash.events.MouseEvent):void
        {
            this.cityItemsScrollingDir = arg1.target.name != "arrowUp" ? 1 : -1;
            this.cityItemsScrollingTimer.start();
            return;
        }

        protected override function update(arg1:com.shadeslider.base.ModelEvent=null):void
        {
            return;
        }

        private function addStageListeners():void
        {
            var loc1:*;
            stageClip.blogCode.addEventListener(flash.events.MouseEvent.CLICK, this.blogCodeClickHandler);
            stageClip.hotStuff.addEventListener(flash.events.MouseEvent.CLICK, this.hotStuffClickHandler);
            stageClip.chooseCity.addEventListener(flash.events.MouseEvent.CLICK, this.chooseCityClickHandler);
            stageClip.collapseWidget.addEventListener(flash.events.MouseEvent.CLICK, this.collapseWidgetClickHandler);
            stageClip.cityDD.arrowUp.addEventListener(flash.events.MouseEvent.ROLL_OVER, this.cityDDArrowUpRollOverHandler);
            stageClip.cityDD.arrowUp.addEventListener(flash.events.MouseEvent.ROLL_OUT, this.cityDDArrowUpRollOutHandler);
            stageClip.cityDD.arrowDown.addEventListener(flash.events.MouseEvent.ROLL_OVER, this.cityDDArrowUpRollOverHandler);
            stageClip.cityDD.arrowDown.addEventListener(flash.events.MouseEvent.ROLL_OUT, this.cityDDArrowUpRollOutHandler);
            this.cityItemsScrollingTimer.addEventListener(flash.events.TimerEvent.TIMER, function (arg1:flash.events.TimerEvent):void
            {
                if ((cityItemsClip.y - 1) > Math.ceil(-(cityItemsClip.height - stageClip.cityDD.msk.height)) && cityItemsScrollingDir < 0)
                {
                    cityItemsClip.y = cityItemsClip.y + cityItemsScrollingDir * 1;
                }
                if (cityItemsClip.y + 1 < 9 && cityItemsScrollingDir > 0)
                {
                    cityItemsClip.y = cityItemsClip.y + cityItemsScrollingDir * 1;
                }
                stageClip.cityDD.arrowDown.visible = cityItemsClip.y + 1 < 9;
                stageClip.cityDD.arrowUp.visible = (cityItemsClip.y - 1) > Math.ceil(-(cityItemsClip.height - stageClip.cityDD.msk.height));
                return;
            })
            return;
        }

        private function chooseCityClickHandler(arg1:flash.events.MouseEvent):void
        {
            stageClip.cityDD.addEventListener(flash.events.MouseEvent.ROLL_OUT, this.cityDDMouseOutHandler);
            com.shadeslider.utils.VisualEffects.fadeIn(stageClip.cityDD, 300);
            return;
        }

        protected override function modelState(arg1:com.shadeslider.base.ModelEvent=null):void
        {
            var loc1:*=model.APP_STATE;
            switch (loc1) 
            {
                case com.shadeslider.project.events.ApplicationStates.APP_INIT:
                {
                    this.initDefaultAppearance();
                    break;
                }
            }
            return;
        }

        private function collapseWidgetClickHandler(arg1:flash.events.MouseEvent):void
        {
            dispatchEvent(new com.shadeslider.project.events.ToolbarViewEvent(com.shadeslider.project.events.ToolbarViewEvent.COLLAPSE));
            return;
        }

        private function hotStuffClickHandler(arg1:flash.events.MouseEvent):void
        {
            dispatchEvent(new com.shadeslider.project.events.ToolbarViewEvent(com.shadeslider.project.events.ToolbarViewEvent.HOT_STUFF));
            return;
        }

        public override function initDefaultAppearance():void
        {
            var lCityDDItemClip:*;
            var lCityDDItemClipClass:Class;
            var lCityIdx:int;
            var lInt:int;
            var lNextItemY:Number;
            var lTextFormat:flash.text.TextFormat;

            var loc1:*;
            lCityDDItemClipClass = null;
            lCityDDItemClip = undefined;
            stageClip.blogCode.buttonMode = true;
            stageClip.blogCode.useHandCursor = true;
            stageClip.hotStuff.buttonMode = true;
            stageClip.hotStuff.useHandCursor = true;
            stageClip.chooseCity.buttonMode = true;
            stageClip.chooseCity.useHandCursor = true;
            stageClip.collapseWidget.buttonMode = true;
            stageClip.collapseWidget.useHandCursor = true;
            stageClip.blogCodeCopiedMessage.visible = false;
            stageClip.cityDD.arrowUp.buttonMode = true;
            stageClip.cityDD.arrowUp.useHandCursor = true;
            stageClip.cityDD.arrowDown.buttonMode = true;
            stageClip.cityDD.arrowDown.useHandCursor = true;
            stageClip.cityDD.arrowDown.visible = false;
            stageClip.cityDD.visible = false;
            lInt = (this.cityItemsClip.numChildren - 1);
            while (lInt >= 0) 
            {
                this.cityItemsClip.removeChildAt(lInt);
                lInt = (lInt - 1);
            }
            lNextItemY = 0;
            lTextFormat = new flash.text.TextFormat();
            lTextFormat.bold = true;
            lCityIdx = 0;
            while (lCityIdx < this.cityList.length) 
            {
                lCityDDItemClipClass = flash.utils.getDefinitionByName("cityDDItem") as Class;
                lCityDDItemClip = new lCityDDItemClipClass();
                lCityDDItemClip.buttonMode = true;
                lCityDDItemClip.useHandCursor = true;
                lCityDDItemClip.mouseChildren = false;
                lCityDDItemClip.name = this.cityList[lCityIdx].code;
                lCityDDItemClip.cityName.text = this.cityList[lCityIdx].name;
                lCityDDItemClip.cityName.setTextFormat(lTextFormat);
                lCityDDItemClip.hoverBg.visible = false;
                lCityDDItemClip.addEventListener(flash.events.MouseEvent.MOUSE_OVER, function (arg1:flash.events.MouseEvent):void
                {
                    arg1.target.hoverBg.visible = true;
                    return;
                })
                lCityDDItemClip.addEventListener(flash.events.MouseEvent.MOUSE_OUT, function (arg1:flash.events.MouseEvent):void
                {
                    arg1.target.hoverBg.visible = false;
                    return;
                })
                lCityDDItemClip.addEventListener(flash.events.MouseEvent.CLICK, function (arg1:flash.events.MouseEvent):void
                {
                    stageClip.cityDD.visible = false;
                    dispatchEvent(new com.shadeslider.project.events.ToolbarViewEvent(com.shadeslider.project.events.ToolbarViewEvent.CHOOSE_CITY, {"code":arg1.target.name}));
                    return;
                })
                lCityDDItemClip.x = 0;
                lCityDDItemClip.y = lNextItemY;
                lNextItemY = lNextItemY + lCityDDItemClip.height - 2.7;
                this.cityItemsClip.addChild(lCityDDItemClip);
                lCityIdx = (lCityIdx + 1);
            }
            return;
        }

        private function cityDDMouseOutHandler(arg1:flash.events.MouseEvent):void
        {
            com.shadeslider.utils.VisualEffects.fadeOut(stageClip.cityDD, 300);
            stageClip.cityDD.removeEventListener(flash.events.MouseEvent.ROLL_OUT, this.cityDDMouseOutHandler);
            return;
        }

        private function blogCodeClickHandler(arg1:flash.events.MouseEvent):void
        {
            var event:flash.events.MouseEvent;

            var loc1:*;
            event = arg1;
            dispatchEvent(new com.shadeslider.project.events.ToolbarViewEvent(com.shadeslider.project.events.ToolbarViewEvent.BLOG_CODE));
            stageClip.blogCodeCopiedMessage.visible = true;
            stageClip.blogCode.removeEventListener(flash.events.MouseEvent.CLICK, this.blogCodeClickHandler);
            com.shadeslider.utils.VisualEffects.fadeOut(stageClip.blogCodeCopiedMessage, 5000);
            flash.utils.setTimeout(function ():*
            {
                stageClip.blogCode.addEventListener(flash.events.MouseEvent.CLICK, blogCodeClickHandler);
                return;
            }, 5000)
            return;
        }

        private function cityDDArrowUpRollOutHandler(arg1:flash.events.MouseEvent):void
        {
            this.cityItemsScrollingTimer.stop();
            return;
        }

        private var cityItemsClip:flash.display.MovieClip;

        private var cityList:Array;

        private var cityItemsScrollingTimer:flash.utils.Timer;

        private var cityItemsScrollingDir:int=1;
    }
}
